/****************************************************************************
    Xplanet 0.90 - render an image of a planet into an X window
    Copyright (C) 2001 Hari Nair <hari@alumni.caltech.edu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/

#ifndef DISPLAYMAGICKPP_H
#define DISPLAYMAGICKPP_H

#include <string>
#include <Magick++.h> 
using namespace std; 

#include "DisplayBase.h"

class DisplayMagickpp : public DisplayBase
{
 public:
    DisplayMagickpp();

    const char *identifyMe();
    void render(ProjectionBase *image);

    void initialize();
    int getFontAscent();
    int getFontDescent();
    int getTextHeight();
    int getTextHeight(const string text);
    int getTextWidth(const string text);
    void setColor(const string color);
    void setFont(string fontname);

 private:
    Magick::Image *thisImage;
    string bg;  // background color
    string fg;  // foreground color

    string currentfont;
    int font_ascent, font_descent;
    int string_height, string_width;

    void drawCircle(const int x, const int y);
    void drawLabel(const string body_label, const string date_label,
		   const string illum_label, const string obs_label,
		   const string sun_label);
    void drawOutlinedString(const int x, const int y, const string text);
};

#endif
